unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ActnList, StdCtrls, ComCtrls, Menus, readthread, ExtCtrls;

type
  TfrmMain = class(TForm)
    tcFrame: TTabControl;
    memoLog: TMemo;
    btnExit: TButton;
    btnOpen: TButton;
    btnClose: TButton;
    lblLogCaption: TLabel;
    lblSerial: TLabel;
    cbPort: TComboBox;
    bvlFrame: TBevel;
    procedure btnOpenClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    rt: TReadCardThread;
    procedure CardRead(var msg: TMessage); message WM_PRPCARD;
  public
    ftHandle: THandle;
  end;

var
  frmMain: TfrmMain;

implementation

uses prp03;

{$R *.DFM}

procedure TfrmMain.CardRead(var msg: TMessage);
begin
  memoLog.Lines.Add('Card code: 0x' + IntToHex(msg.WParam, 8) + ' (' + IntToHex(msg.LParam, 2) + ')');
end;

procedure TfrmMain.btnOpenClick(Sender: TObject);
begin
  btnOpen.Enabled := false;
  btnClose.Enabled := true;
  ftHandle := InitCom(cbPort.ItemIndex + 1);
  if ftHandle <> COMInvHandle then
  begin
    memoLog.Lines.Add('InitCom = ' + IntToStr(ftHandle));
    rt := TReadCardThread.Create(true);
    rt.HWND := Handle;
    rt.usb := ftHandle;
    rt.Resume;
  end else
  begin
    btnOpen.Enabled := true;
    btnClose.Enabled := false;
    memoLog.Lines.Add('InitCom Error (' + IntToStr(ftHandle) + ')');
  end;
end;

procedure TfrmMain.btnCloseClick(Sender: TObject);
begin
  rt.Terminate;
  memoLog.Lines.Add('CloseCom(' + IntToStr(ftHandle) + ')');
  CloseCom(ftHandle);
  btnOpen.Enabled := true;
  btnClose.Enabled := false;
end;

procedure TfrmMain.btnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  cbPort.ItemIndex := 0;
end;

end.
